#ifndef EXEC_IX86BE_H
#define EXEC_IX86BE_H
/*
**      $VER: ix86be.h 1.0 (09.01.2005)
**
**      Include file for use by native ix86be Amithlon/Umilator programs
**
**      (C) Copyright 2005 Martin Blom
**          All Rights Reserved
*/

#ifndef EXEC_TYPES_H
# include <exec/types.h>
#endif

#ifndef EXEC_SEMAPHORES_H
# include <exec/semaphores.h>
#endif


/*** RomTag/MakeFunctions() extensions  **************************************/

#define RTF_IX86BE (1<<3)

#ifndef FUNCARRAY_32BIT_NATIVE
# define FUNCARRAY_32BIT_NATIVE 0xfffefffe
#endif


/*** Module startup code  ****************************************************/

#define IX86BE_ENTRY \
__asm__ ("				\n\\\
	.text;				\n\\\
	.byte 0x4e, 0xfa, 0x00, 0x03	\n\\\
	jmp _start" );


/*** Identification semaphore ************************************************/

struct RunELF86
{
    struct SignalSemaphore Semaphore;
    UWORD                  Version;
    UWORD                  Revision;
};


/*** Resident/Base-relative code support *************************************/

struct RunELF86FSContext
{
    ULONG const		   Length;	/* Length of this struct */
    struct ExecBase* const ExecBase;	/* A copy of SysBase */
    APTR		   UserData;	/* Any process may use this at
					   will, but it has to use
					   tc_Switch/tc_Launch to
					   save/restore it! */
    /* More fields may be added later */
};

static inline ULONG GetRunELF86FSLength(void) {
  ULONG v;
  __asm__ volatile ("movl %%fs:0, %0" : "=q" (v));
  return v;
}

static inline struct ExecBase* GetRunELF86FSSysBase(void) {
  struct ExecBase* v;
  __asm__ volatile ("movl %%fs:4, %0" : "=q" (v));
  return v;
}

static inline APTR GetRunELF86FSUserData(void) {
  APTR  v;
  __asm__ volatile ("movl %%fs:8, %0" : "=q" (v));
  return v;
}

static inline void SetRunELF86FSUserData(APTR v) {
  __asm__ volatile ("movl %0, %%fs:8" : : "q" (v));
}


/*** 68000 function call stuff ***********************************************/

#ifndef __INLINE_MACROS_H_REGS
#define __INLINE_MACROS_H_REGS

struct _Regs
{
    ULONG d0;
    ULONG d1;
    ULONG d2;
    ULONG d3;
    ULONG d4;
    ULONG d5;
    ULONG d6;
    ULONG d7;
    ULONG a0;
    ULONG a1;
    ULONG a2;
    ULONG a3;
    ULONG a4;
    ULONG a5;
    ULONG a6;
    ULONG a7;
};

#endif /* __INLINE_MACROS_H_REGS */

ULONG _CallLib68k(struct _Regs*,LONG) __attribute__((__regparm__(3)));
ULONG _CallFunc68k(struct _Regs*, void*) __attribute__((__regparm__(3)));

#endif /* EXEC_IX86BE_H */
